using System;
using System.Runtime.InteropServices;
using Mono.Unix;
using Gtk;

namespace Dopi {

    internal delegate void BaconHandler ([MarshalAs (UnmanagedType.LPStr)] string msg, IntPtr data);
    
    public class EntryPoint {

        private static DopiWindow window;

        [DllImport ("bacon")]
        private static extern IntPtr bacon_message_connection_new ([MarshalAs (UnmanagedType.LPStr)] string name);

        [DllImport ("bacon")]
        private static extern int bacon_message_connection_get_is_server (IntPtr conn);

        [DllImport ("bacon")]
        private static extern void bacon_message_connection_set_callback (IntPtr conn, BaconHandler handler,
                                                                          IntPtr blah);

        [DllImport ("bacon")]
        private static extern void bacon_message_connection_send (IntPtr conn, [MarshalAs (UnmanagedType.LPStr)] string msg);

        public static void Main (string[] args) {
            Application.Init ();
            Catalog.Init ("dopi", BuildConfig.LOCALE_DIRECTORY);

            IntPtr conn = bacon_message_connection_new ("dopi");
            if (bacon_message_connection_get_is_server (conn) == 0) {
                bacon_message_connection_send (conn, "present");
                return;
            } else {
                bacon_message_connection_set_callback (conn, OnBaconMessage, IntPtr.Zero);
            }

            window = new DopiWindow ();
            window.Show ();

            try {
                Application.Run ();
            } catch (Exception e) {
                Console.Error.WriteLine (e);
                window.ShowError (Catalog.GetString ("An unexpected error occurred, Dopi will now quit:"), e.Message);
            }
        }

        private static void OnBaconMessage (string msg, IntPtr data) {
            window.Present ();
        }
    }
}
